include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
axiom nat : Type[0].
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
axiom filter_nat_type : \forall return_ : Type[0] . (nat -> return_) -> nat -> return_.
axiom axiom_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (equal) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)).
definition eq_filter_nat_type_S : \forall return_type. \forall (return_:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((filter_nat_type) (return_type) return_ ((S)  n)) (return_ ((S)  n)) := \lambda return_type : Type[0]. \lambda return_ : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((filter_nat_type) (return_type) return_ ((S)  n))) (return_ ((S)  n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
axiom minus : nat -> nat -> nat.
axiom minus_body : nat -> nat -> nat.
axiom axiom_minus : \forall (n:nat). (equal) (nat -> nat) ((minus)  n) ((filter_nat_type) (nat -> nat) (minus_body)  n).
definition eq_minus : \forall (n:nat). (leibniz) (nat -> nat) ((minus)  n) ((filter_nat_type) (nat -> nat) (minus_body)  n) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((minus)  n)) ((filter_nat_type) (nat -> nat) (minus_body)  n)) ((axiom_minus) (n)).
axiom axiom_minus_body_S : \forall (n:nat). (equal) (nat -> nat) ((minus_body)  ((S)  n)) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m).
definition eq_minus_body_S : \forall (n:nat). (leibniz) (nat -> nat) ((minus_body)  ((S)  n)) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m) := \lambda n : nat. ((((equal_leibniz) (nat -> nat)) ((minus_body)  ((S)  n))) (\lambda m : nat. (match_nat_type) (nat) ((S)  n) (\lambda q : nat. (minus)  n q) m)) ((axiom_minus_body_S) (n)).
definition minus_S_S : \forall (n:nat). \forall (m:nat). (eq) (nat) ((minus)  ((S)  n) ((S)  m)) ((minus)  n m) := \lambda n : nat. \lambda m : nat. ((((((eq_match_nat_type_S) (nat)) ((S)  n)) (\lambda q : nat. (minus)  n q)) (m)) (\lambda y : nat. (eq) (nat) ((minus)  ((S)  n) ((S)  m)) y)) ((((eq_minus_body_S) (n)) (\lambda y : nat -> nat. (eq) (nat) ((minus)  ((S)  n) ((S)  m)) (y ((S)  m)))) ((((((eq_filter_nat_type_S) (nat -> nat)) ((minus_body) )) (n)) (\lambda y : nat -> nat. (eq) (nat) ((minus)  ((S)  n) ((S)  m)) (y ((S)  m)))) ((((eq_minus) ((S)  n)) (\lambda y : nat -> nat. (eq) (nat) ((minus)  ((S)  n) ((S)  m)) (y ((S)  m)))) (((refl) (nat)) ((minus)  ((S)  n) ((S)  m)))))).
